# dbhelper.py - database access helper functions
# $Id: dbhelper.py 5068 2003-07-19 12:43:00Z voss $
#
# Copyright 2003  Jochen Voss <voss@mathematik.uni-kl.de>
#
# This module contains helper functions for the golist scripts.
# These help to access the SQL database and to convert between
# textual and numerical strength values.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

def get_tokens(c):
    "Get the list of all player tokens."
    c.execute("SELECT token FROM player")
    return  map(lambda p:p[0],c.fetchall())

def rank_to_strength (rank):
    num=rank[:-1]
    sig=rank[-1]
    if sig == "k":
        return -float(num)
    elif sig == "d":
        return float(num)-1
    else:
        raise "invalid rank "+rank

def strength_to_rank (strength):
    x=round(strength)
    if x<0:
        rank="%dk" % -x
    else:
        rank="%dd" % (x+1)
    return rank

def get_player_strength(c, token):
    "Get the current strength of player TOKEN."
    c.execute ("SELECT rank,strength FROM player WHERE token = '%s'" % token)
    x=c.fetchone()
    if x[1]: return x[1]
    if x[0]: return rank_to_strength(x[0])
    return None

def get_historic_player_strength(c, token, date):
    "Get the strength of player TOKEN at time DATE."
    c.execute ("SELECT strength FROM history"
               +" WHERE token='%s'" % token
               +" AND validfrom <= '%s'" % date.Format("%Y-%m-%d")
               +" ORDER BY validfrom DESC LIMIT 1")
    x=c.fetchone()
    if x: return x[0]
    return None

def sql_write_line(c,table,dict):
    fields=dict.keys()
    values=dict.values()
    c.execute("INSERT INTO %s ("%table+",".join(fields)+")"
              + " VALUES (" + ",".join(["%s"]*len(fields)) + ")",
              values)
