/* gameprob.h - declarations for "gameprob.c"
 * $Id: gameprob.h 5068 2003-07-19 12:43:00Z voss $
 *
 * Copyright (C) 2002, 2003  Jochen Voss <voss@mathematik.uni-kl.de>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef FILE_GAMEPROB_H_SEEN
#define FILE_GAMEPROB_H_SEEN

/* parameters */
struct param_info {
  int id;
  char *name;
  double *ptr;
  double  default_value, min, max;
  int  board;
};

extern  void  init_parameters (void);
extern  void  register_parameter (int id, const char *name);
extern  struct param_info *find_parameter (int id);
extern  struct param_info *find_param_by_name (const char *name);
extern  void  set_param (int id, double val);
extern  double  get_param (int id);

/* games */
enum result { res_BLACK, res_WHITE, res_JIGO };

struct game_info {
  int id;
  int black, white;
  int board, hc, komi, with_jigo;
  enum result  res;
};

extern  void  register_game (int id, int black, int white, int board,
			     int hc, int komi, int with_jigo,
			     const char *res);
extern  double  probability (int black, int white, int board,
			     int hc, int komi, int with_jigo,
			     enum result res);
extern  double  game_prob (int game);
extern  int  applies_to (int param, int game);

#endif /* FILE_GAMEPROB_H_SEEN */
