--
-- Create empty tables for the golist database.
-- Be careful: this deletes any previously stored golist database.
--
-- Usage:
--    mysql golist <golist.sql
--

DROP TABLE IF EXISTS player;
CREATE TABLE player (
  token varchar(12) NOT NULL PRIMARY KEY,
  name varchar(40) default NULL,
  rank char(3) default NULL,
  strength double default NULL,
  component smallint(6) default NULL,
  visible char(1) default 'y'
) TYPE=MyISAM;

DROP TABLE IF EXISTS game;
CREATE TABLE game (
  id int NOT NULL auto_increment PRIMARY KEY,
  gamedate date default NULL,
  black varchar(12) NOT NULL default '',
  white varchar(12) NOT NULL default '',
  board tinyint(2) NOT NULL default '19',
  handicap tinyint(2) NOT NULL default '0',
  komi tinyint(2) NOT NULL default '0',
  withjigo char(1) default 'y',
  result enum('black','white','jigo') NOT NULL default 'black',
  probability double default NULL,
  INDEX(black),
  INDEX(white)
) TYPE=MyISAM;

DROP TABLE IF EXISTS history;
CREATE TABLE history (
  id int NOT NULL auto_increment PRIMARY KEY,
  token varchar(12) NOT NULL,
  validfrom date NOT NULL,
  strength double NOT NULL default -15,
  fix double,
  settled char(1) default 'n',
  INDEX(validfrom)
) TYPE=MyISAM;

DROP TABLE IF EXISTS parameters;
CREATE TABLE parameters (
  name varchar(8) NOT NULL PRIMARY KEY,
  value double default NULL
) TYPE=MyISAM;
