DROP TABLE IF EXISTS gustmp;
CREATE TABLE gustmp (
  gd date NOT NULL,
  hd date NOT NULL,
  token varchar(12) NOT NULL,
  KEY(hd),
  KEY(token)
);
INSERT INTO gustmp
  SELECT gamedate,MAX(validfrom) as histdate,token FROM history,game
  WHERE (black=token OR white=token) AND validfrom<=gamedate
  GROUP BY gamedate,token;
EXPLAIN
SELECT game.id, tb.token, tw.token, hb.id, hw.id, board, handicap, komi, withjigo, result
  FROM game, gustmp AS tb, gustmp as tw, history as hb, history as hw
  WHERE tb.token=black AND tb.gd=gamedate AND hb.token=black AND hb.validfrom=tb.hd
    AND tw.token=white AND tw.gd=gamedate AND hw.token=white AND hw.validfrom=tw.hd;
-- DROP TABLE gustmp;
